﻿using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace Credits
{
	public partial class MainPage : UserControl
	{
		public MainPage()
		{
			// Required to initialize variables
			InitializeComponent();
            Blink.AutoReverse = true;
            Blink.Completed += new EventHandler(Blink_Completed);
            Blink.Begin();
    	}

        void Blink_Completed(object sender, EventArgs e)
        {
            BlinkAgain();
        }

        private void BlinkAgain()
        {
            Blink.Stop();
            var name = "E" + new Random().Next(Starfield.Children.Count);
            Blink.Children[0].SetValue(Storyboard.TargetNameProperty, name);
            Blink.Children[1].SetValue(Storyboard.TargetNameProperty, name);
            Blink.Begin();	
        }

        private void FillStarfield()
        {
            Starfield.Children.Clear();
            var h = Background.ActualHeight;
            var w = Background.ActualWidth;
            var r = new Random();
            for(int i=0;i<(w+h)/2;i++)
            {
                var x = r.Next((int)w);
                var y = r.Next((int)h);
                var e = new Ellipse();
                e.Name= "E"+ i;
                Canvas.SetLeft(e, x);
                Canvas.SetTop(e, y);
                if (i % 10 == 0)
                {
                    e.Width = 4;
                    e.Height = 4;
                }
                else
                {
                    e.Width = 2;
                    e.Height = 2;
                }
                e.Fill = First.Fill;
                Starfield.Children.Add(e);
            }
        }

		private void UserControl_Loaded(object sender, System.Windows.RoutedEventArgs e)
		{
            try
            {
                Text.Text = (String)App.Current.Resources["text"].ToString().Replace("\\n", "\r\n");
            }
            catch (Exception)
            {
                Text.Text = "No text provided!";
            }
		}

		private void UserControl_SizeChanged(object sender, System.Windows.SizeChangedEventArgs e)
		{
            FillStarfield();
            Move.Stop();
            Move.Begin();
		}

		private void UserControl_MouseLeftButtonDown(object sender, System.Windows.Input.MouseButtonEventArgs e)
		{
            Move.Stop();
            Move.Begin();
		}

	}
}